USE [WaspTrackInventory]
GO

if EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[vItemAvgCost]') and OBJECTPROPERTY(id, N'IsView') = 1)
DROP VIEW [dbo].[vItemAvgCost]
GO

SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

CREATE VIEW [dbo].[vItemAvgCost]
AS
SELECT     item_id, SUM(total_value) / SUM(quantity) AS avg_cost
FROM         dbo.item_cost
WHERE     (site_id = 0)
GROUP BY item_id
HAVING      (SUM(quantity) > 0)

GO


if EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[vInventoryAvgCost]') and OBJECTPROPERTY(id, N'IsView') = 1)
DROP VIEW [dbo].[vInventoryAvgCost]
GO

SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

CREATE VIEW [dbo].[vInventoryAvgCost]
AS
SELECT     dbo.inventory.inventory_id, dbo.inventory.quantity, dbo.inventory.record_status, dbo.inventory.company_id, dbo.item.item_number, dbo.item.description, 
                      ISNULL(dbo.vItemAvgCost.avg_cost, dbo.item.avgcost) AS avgcost, dbo.location.code, dbo.sites.description AS siteDes, dbo.sites.site_name, dbo.sites.site_id, 
                      dbo.item.record_status AS item_record_status, dbo.item.cost_calc_method, dbo.item_costing_method.method_name
FROM         dbo.item INNER JOIN
                      dbo.inventory ON dbo.item.item_id = dbo.inventory.item_id INNER JOIN
                      dbo.location ON dbo.inventory.location_id = dbo.location.location_id INNER JOIN
                      dbo.sites ON dbo.location.site_id = dbo.sites.site_id INNER JOIN
                      dbo.item_costing_method ON dbo.item.cost_calc_method = dbo.item_costing_method.costing_method_id LEFT OUTER JOIN
                      dbo.vItemAvgCost ON dbo.inventory.item_id = dbo.vItemAvgCost.item_id
WHERE     (dbo.inventory.quantity > 0) AND (dbo.item.record_status = 1)

GO


if NOT EXISTS (select * from report_names where rpt_id = 220 )
begin
	insert into report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) values (220,2,14,'Inventory Average Cost Report','Inventory Average Cost Report','Inventory Average Cost Report','F','F','The average cost of existing inventory of items.','P');
end
GO

DELETE FROM report_labels WHERE rpt_id = 220
GO

insert into report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (220,'quantity',null,'Inventory',6,'qty_available',null);
insert into report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (220,'item_number',null,'Item',6,'item_number',null);
insert into report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (220,'description',null,'Item',6,'description',null);
insert into report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (220,'avgcost',null,'Item',6,'avgcost',null);
insert into report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (220,'code',null,'Location',7,'code',null);
insert into report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (220,'site_name',null,'Site',8,'site_name',null);
insert into report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (220,'code',null,'Location',7,'code',null);
GO
